''This is early beta... it works, but it will be changed substantially in upcoming releases.



''NOTE...  prop pins 12, 13, and 15, which communicate with the MCP3208 ADC, are declared both here and in MCP3208_fast_rjo


''Stereo_TSL1401_mcp3208_rjo_007 controls and displays output from two tsl1401 line scanners with a single Prop. 
''Stereo_TSL_UI_rjo_007 runs on a second Prop and stores data from the stereo camera to a uSD card.
''in the next iteration, the UI prop will also control an additional stereo camera, and the pan and tilt
''In this version, acquisitions are stored to a uSD card when a trigger button attached to  Pin 1 is pushed.
''in the future, acquisitions will be controlled by the UI prop.

''Acquisition storage is indicated by an LED attached to pin 3 of the camera prop.


''Hardware:
''+3.3 Volts everywhere.

''Aside from 1k resistors on data lines, there is a single transistor(TIP120), with base connected to the Propeller Pin 9 for SI signal to TSL1401.  This transistor switches VDD to SI
''and drives output to the SI pins of the TSL1401.   For additional setup info of the TSL and MCP units,  see device data sheet and documentation
''in the Parallax store.  Additional diagrams will be posted to the this thread.

''Knobs... a knob is used to set windowing of pixel values.  This knob consists of a 1K pot  connected to VDD. Output is tied to ground with
''a 1.5K resistor and fed into MCP3208 channel 2.

 
''PERFORMANCE:  With this code there is a time step resolution for the integration period of 5.6usec.  Minimum
''integration period is 44.8 usec.    The integration period is set through the "TIP" variable.  Presently this value is
''set in the Paraminit method.  The TSL1401 is capable of better performance.  And with more clever
''programming, the Prop can easily drive the TSL1401 at its theoretical maximums.

''With present performance, the Prop is driving two TSL1401s with a combined burst pixel rate of approximately 2.5M Pixels per second.
''Of course effective acquisition rates are governed by the single shot mode implementation and by the ADC, which at 3.3V is about 25Ksps.

''Integration Period clocks  = 3138 + (448*TIP) clocks


''Both TSL-s get exactly the same signals from exactly the same Prop pins at the precisely the same time ... except for differences caused by the path lengths of the
''wires.  The analog data from the TSLs is output to channels 0 and 1 of the MCP.  Data is read back by alternating between channels 0 and 1 for
''each successive pixel read.

''So, the time order of the ADC process (time at which each pixel is read) is also roughly the same.



''PROBLEMS:

''This is a rapid prototype.  There is a little noise in the pixel data.  This is probably
''because I have tied the source +V to the reference +V in the MCP circuit and have added no filtering caps.  The noise level
''is acceptable for my applications...  it may not be for yours.  See device data sheets for further
''help.

''There has been one hardware glitch...  I returned after several hours to find the display screen appearing to
''be frozen.

''For video display, full windowing logic is not included.  Instead, raw pixel values are divided by the  "range" variable before being plotted to screen.
''For this demo, the range variable is set to a value of one (in the Plot method).  In actual use, the value is set by a
''reading the knob

'' Legal use:

''As with everything  I post to the forum, this code is free for use for any purpose, with or without attribution... so long as the original authors of supporting Objects
''do not indicate otherwise.

''rjo  Feb-March 2010



CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 1
  reps = 4
  bpin =20  'video basepine
  indicator = 1
  strobe = 7

  tsl_clk  =8
  tsl_si   = 9
  mcp_clk  = 15
  mcp_data = 13
  mcp_cs   = 12
  triggerIn  = 2          'trigger in
  channel  = 0    'mcp base channel
  remote  = 4

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  long range,center,voffset,maxval,minval,cmd,t1,tip,maxdifflpix,noisefloor,temp
  long maxdiffrpix,aL,aR,aP,gotangle,pD,distance,lastdistance
  word dataL[128],dataR[128]     
OBJ
  io    :"FullDuplexSerial"
  tv    : "tv"
  gr    : "graphics2"
  MCP   : "MCP3208_fast_rjo"
  tsl   : "tsl1401asm_rjo_001"
PUB start | i,line
  io.start(10,11,0,115200)
  InitParams
  gr.start
  mcp.start(mcp_data,mcp_clk,mcp_cs)
  gr.setup(16, 12, 128, 96, bitmap_base)
  dira[tsl_clk]:=dira[tsl_si]:=dira[strobe]:=dira[indicator]:=1
  cmd:=1
  tsl.start(@cmd)
  repeat until cmd == 0
  line:=-128
  repeat
    repeat until ina[triggerin]==1
    outa[indicator]:=1
    plotline(line)

    getimage
    if line==-128                                              
      temp:=sendimage
      outa[indicator]:=0
      repeat until ina[triggerin] == 1
    gr.clear
    gr.copy(display_base)
    outa[indicator]:=1
    subtractimage
    'plot 
    temp:=sendimage
    line:=line+2
    if line > 128
       line:=-128
    outa[indicator]:=0
    
pub sendimage |i
    i:=0
    repeat 256
     io.tx(byte[@datal][i])
     i++
    i:=0
    repeat 256
     io.tx(byte[@datar][i])
     i++
                   
pub getimage | i,tester
 cmd:=1

 repeat until cmd==0
 i:=0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      datar[i]:=(mcp.in(channel))
      datal[i]:=(mcp.in(channel+1))
      i++

Pub SubtractImage | i
 i:=0
 cmd:=1

 repeat until cmd==0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      
      datal[i]:=||(datal[i]-(mcp.in(channel+1)) )
      datar[i]:=||(datar[i]-(mcp.in(channel)))
      i++


pub plot  |i, j,jj,k, kk,px,py,dechr,gotleft,gotright

    gr.clear
    gr.colorwidth(3,0)
    gr.colorwidth(2,0 )
   ' gr.text(64,80,@pchip)
    range:=readKnob
    range:=(8000/range )
    if range > 10
       range:=range*2
    range:=10
    gr.colorwidth(2,0)
    repeat i from 0 to 126
      px:=i-128
      py:= ((dataL[i])/range)-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
      px:=i
      py:= ((dataR[i])/range  )-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
                  
    gr.colorwidth(3,0)
    dechr:="L"
    gr.text(-64,-92,@dechr)
    dechr:="R"
    gr.text(64,-92,@dechr)
    gr.text(-90,80,@PixelVal)
    gr.text(-120,70,@IntegPeriod)
    gotleft:=1

               '
                                    't1 is total clocks in integration period, t1 is written by pasm routine
                                    'in tsl1401asm_rjo_001
    t1:=t1/(clkfreq/1_000_000)      't1 is now microseconds of integration period
    plotint(t1,0,70)                'write integration period to screen
    plotInt(range,-60,80)
    
    gr.color(2)

    gr.colorwidth(2,0)
    gr.copy(display_base)
Pub PlotLine(whichline)

      gr.plot (whichline,-100)
      gr.line (whichline,100)
      gr.copy(display_base)
Pub readKnob
                                         'If this isn't the worst knob in the world... it has to come close
                                         'Again it does what I want it to do:)  But it is really ugly
    maxval:=mcp.in(channel+2)
    if maxval//100 > 50
    
      maxval:=maxval/100
    
      maxval:=maxval*100
      maxval:=maxval+50
    else
      maxval:=(maxval/100)*100
    maxval:=maxval + 45
    if maxval > 4095
       maxval := 4095
    return maxval
Pub plotInt (value,x,y) | i,kk,dechr
    i:=0                           
    repeat until value == 0
       kk:=value//10
       value:=value/10
       dechr:=num +kk
       gr.text(x-(i*6),y,@dechr)
       i:=i+1 


    
Pub InitParams   | i,dx,dy
  Tip:=60000         'TSL integration period parameter....integration clocks =  3136 + (448*tip)
  voffset:=94    'adjusts plot x,y location.  Can be used in future to implement full windowing logic
  noisefloor:=50
  pD:=74
  longmove(@tv_status, @tvparams, paramcount)
  
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat i from 0 to 16
    colors[i] := $00001010 * (i+20) & $F + $2B060C02
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
                             
 

 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long     (bpin & $38) << 1 | (bpin & 4 == 4) & %0101 
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog
IntegPeriod             byte    "Integ(usec)",0
PixelVal                byte    "Pix/ ",0
'pchip                   byte    "Propeller",0           'text
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0